/**
 * @file IxHssAccSymbols.c
 *
 * @author Intel Corporation
 * @date 04-Oct-2002
 *
 * @brief This file declares exported symbols for linux kernel module builds.
 *
 * 
 * @par
 * IXP400 SW Release version 2.3
 * 
 * -- Copyright Notice --
 * 
 * @par
 * Copyright (c) 2001-2005, Intel Corporation.
 * All rights reserved.
 * 
 * @par
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Intel Corporation nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * 
 * @par
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * 
 * @par
 * -- End of Copyright Notice --
 */

#ifdef __linux

#include <linux/module.h>
#include <IxHssAcc.h>

EXPORT_SYMBOL(ixHssAccPortInit);
EXPORT_SYMBOL(ixHssAccLastErrorRetrievalInitiate);
EXPORT_SYMBOL(ixHssAccInit);
EXPORT_SYMBOL(ixHssAccPktPortConnect);
EXPORT_SYMBOL(ixHssAccPktPortEnable);
EXPORT_SYMBOL(ixHssAccPktPortDisable);
EXPORT_SYMBOL(ixHssAccPktPortDisconnect);
EXPORT_SYMBOL(ixHssAccPktPortIsDisconnectComplete);
EXPORT_SYMBOL(ixHssAccPktPortRxFreeReplenish);
EXPORT_SYMBOL(ixHssAccPktPortTx);
EXPORT_SYMBOL(ixHssAccChanConnect);
EXPORT_SYMBOL(ixHssAccChanPortEnable);
EXPORT_SYMBOL(ixHssAccChanPortDisable);
EXPORT_SYMBOL(ixHssAccChanDisconnect);
EXPORT_SYMBOL(ixHssAccChanStatusQuery);
EXPORT_SYMBOL(ixHssAccShow);
EXPORT_SYMBOL(ixHssAccStatsInit);
EXPORT_SYMBOL(ixHssAccChanTslotSwitchEnable);
EXPORT_SYMBOL(ixHssAccChanTslotSwitchDisable);
EXPORT_SYMBOL(ixHssAccChanTslotSwitchGctDownload);
EXPORT_SYMBOL(ixHssAccUninit);
#endif /* __linux */
